/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Horarepeticao;
import com.tabajara.base.tables.records.HorarepeticaoRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.sql.Date;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class HorarepeticaoDao extends AbstractVertxDAO<HorarepeticaoRecord, com.tabajara.base.tables.pojos.Horarepeticao, Integer, Future<List<com.tabajara.base.tables.pojos.Horarepeticao>>, Future<com.tabajara.base.tables.pojos.Horarepeticao>, Future<Integer>, Future<Integer>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<HorarepeticaoRecord,com.tabajara.base.tables.pojos.Horarepeticao,Integer> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public HorarepeticaoDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Horarepeticao.HORAREPETICAO, com.tabajara.base.tables.pojos.Horarepeticao.class, new JDBCClassicQueryExecutor<HorarepeticaoRecord,com.tabajara.base.tables.pojos.Horarepeticao,Integer>(com.tabajara.base.tables.pojos.Horarepeticao.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Integer getId(com.tabajara.base.tables.pojos.Horarepeticao object) {
        return object.getHorid();
    }

    /**
     * Find records that have <code>horhora IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Horarepeticao>> findManyByHorhora(List<String> values) {
        return findManyByCondition(Horarepeticao.HORAREPETICAO.HORHORA.in(values));
    }

    /**
     * Find records that have <code>hordiainicial IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Horarepeticao>> findManyByHordiainicial(List<Date> values) {
        return findManyByCondition(Horarepeticao.HORAREPETICAO.HORDIAINICIAL.in(values));
    }

    /**
     * Find records that have <code>horrepetiracada IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Horarepeticao>> findManyByHorrepetiracada(List<Integer> values) {
        return findManyByCondition(Horarepeticao.HORAREPETICAO.HORREPETIRACADA.in(values));
    }

    /**
     * Find records that have <code>hortiporepeticao IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Horarepeticao>> findManyByHortiporepeticao(List<String> values) {
        return findManyByCondition(Horarepeticao.HORAREPETICAO.HORTIPOREPETICAO.in(values));
    }
}
